/**
 * @file
 * Initializes the Affirm API.
 */

((Drupal, once) => {
  Drupal.behaviors.commerceAffirm = {
    attach: (context, settings) => {
      once('commerceAffirm', 'body', context).forEach((element) => {
        const config = settings.commerce_affirm || {};

        // Determine the appropriate library URL based on country and mode.
        const liveUrl =
          config.CountryCode === 'CAN'
            ? 'https://cdn1.affirm.ca/js/v2/affirm.js'
            : 'https://cdn1.affirm.com/js/v2/affirm.js';
        const sandboxUrl =
          config.CountryCode === 'CAN'
            ? 'https://cdn1.sandbox.affirm.ca/js/v2/affirm.js'
            : 'https://cdn1.sandbox.affirm.com/js/v2/affirm.js';
        const url = config.ApiMode === 'live' ? liveUrl : sandboxUrl;

        // eslint-disable-next-line camelcase
        const _affirm_config = {
          public_api_key: config.hasOwnProperty('PublicKey')
            ? config.PublicKey
            : '',
          script: url,
          locale: config.Locale,
          country_code: config.CountryCode,
        };
        if (config.hasOwnProperty('SessionId')) {
          // eslint-disable-next-line camelcase
          _affirm_config.session_id = config.SessionId;
        }
        // eslint-disable-next-line
        (function(m,g,n,d,a,e,h,c){var b=m[n]||{},k=document.createElement(e),p=document.getElementsByTagName(e)[0],l=function(a,b,c){return function(){a[b]._.push([c,arguments])}};b[d]=l(b,d,"set");var f=b[d];b[a]={};b[a]._=[];f._=[];b._=[];b[a][h]=l(b,a,h);b[c]=function(){b._.push([h,arguments])};a=0;for(c="set add save post open empty reset on off trigger ready setProduct".split(" ");a<c.length;a++)f[c[a]]=l(b,d,c[a]);a=0;for(c=["get","token","url","items"];a<c.length;a++)f[c[a]]=function(){};k.async=!0;k.src=g[e];p.parentNode.insertBefore(k,p);delete g[e];f(g);m[n]=b})(window,_affirm_config,"affirm","checkout","ui","script","ready","jsReady");
      });
    },
  };
})(Drupal, once);
