/**
 * @file
 * Send a checkout request to Affirm API.
 */

((Drupal, once) => {
  Drupal.behaviors.commerceAffirmCheckout = {
    attach: (context, settings) => {
      once('commerceAffirmCheckout', 'body', context).forEach((element) => {
        const config = settings.commerce_affirm;
        // eslint-disable-next-line no-undef
        affirm.checkout({
          merchant: {
            user_confirmation_url: config.ConfirmUrl,
            user_confirmation_url_action: 'POST',
            user_cancel_url: config.CancelUrl,
          },
          billing: {
            name: {
              full: config.BillingFullName,
              first: config.BillingFirstName,
              last: config.BillingLastName,
            },
            address: {
              line1: config.BillingAddressLn1,
              line2: config.BillingAddressLn2,
              city: config.BillingAddressCity,
              state: config.BillingAddressState,
              zipcode: config.BillingAddressPostCode,
              country: config.BillingAddressCountry,
            },
            email: config.Email,
            phone_number: config.BillingTelephone,
          },
          items: config.items,
          shipping: {
            name: {
              full: config.ShippingFullName,
              first: config.ShippingFirstName,
              last: config.ShippingLastName,
            },
            address: {
              line1: config.ShippingAddressLn1,
              line2: config.ShippingAddressLn2,
              city: config.ShippingAddressCity,
              state: config.ShippingAddressState,
              zipcode: config.ShippingAddressPostCode,
              country: config.ShippingAddressCountry,
            },
            email: config.Email,
            phone_number: config.ShippingTelephone,
          },
          discounts: config.discounts,
          metadata: config.metadata,
          shipping_amount: config.ShippingTotal,
          tax_amount: config.TaxAmount,
          total: config.ProductsTotal,
          currency: config.OrderCurrency,
        });

        // Submit and redirect to checkout flow.
        // eslint-disable-next-line no-undef
        affirm.checkout.open();
      });
    },
  };
})(Drupal, once);
